## [9.0.0] - 2022-05-30

### Fixed

- NetBios
  - Fixes configuring network adapters in a disconnected or disabled state - fixes [Issue #434](https://github.com/dsccommunity/NetworkingDsc/issues/434).
- DnsServerAddress
  - Improved error handling - fixes [Issue #446](https://github.com/dsccommunity/NetworkingDsc/issues/446).

### Changed

- NetAdapterLso
  - Protocol now a key field allowing multiple protocol configurations for a
    single network adapter - fixes [Issue #475](https://github.com/dsccommunity/NetworkingDsc/issues/475).
  - Updated wiki documentation showing configuration overlap with
    NetAdapterAdvancedProperty - fixes [Issue #475](https://github.com/dsccommunity/NetworkingDsc/issues/475).
- NetAdapterAdvancedProperty
  - Updated wiki documentation showing configuration overlap with
    NetAdapterLso - fixes [Issue #475](https://github.com/dsccommunity/NetworkingDsc/issues/475).
- Renamed `master` branch to `main` - Fixes [Issue #469](https://github.com/dsccommunity/NetworkingDsc/issues/469).
- Updated build to use `Sampler.GitHubTasks` - Fixes [Issue #489](https://github.com/dsccommunity/NetworkingDsc/issues/489).
- Added support for publishing code coverage to `CodeCov.io` and
  Azure Pipelines - Fixes [Issue #491](https://github.com/dsccommunity/NetworkingDsc/issues/491).
- Minor reformatting of code style for diffability.
- ProxySettings
  - Added function `Get-ProxySettingsRegistryKeyPath` to provide initial
    support for changing proxy settings for current user.
    BREAKING CHANGE: Added support for configuring proxy settings for a user
    account by adding `Target` parameter - Fixes [Issue #423](https://github.com/dsccommunity/NetworkingDsc/issues/423).
- Updated .github issue templates to standard - Fixes [Issue #508](https://github.com/dsccommunity/NetworkingDsc/issues/508).
- Added Create_ChangeLog_GitHub_PR task to publish stage of build pipeline.
- Added SECURITY.md.
- Updated pipeline Deploy_Module anb Code_Coverage jobs to use ubuntu-latest
  images - Fixes [Issue #508](https://github.com/dsccommunity/NetworkingDsc/issues/508).
- Updated pipeline unit tests and integration tests to use Windows Server 2019 and
  Windows Server 2022 images - Fixes [Issue #507](https://github.com/dsccommunity/NetworkingDsc/issues/507).
- NetAdapterState
  - Added a new message when setting the state of an adapter.

### Fixed

- Fixed pipeline by replacing the GitVersion task in the `azure-pipelines.yml`
  with a script.
- NetAdapterState
  - Fixed so that the resource is idempotent so that `Enable-NetAdapter` and
    `Disable-NetAdapter` are only called when change is required.
- NetAdapterLso
  - Fixed integration tests so that they will be skipped if a network adapter
    with NDIS version 6 or greater is not available.


