# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_defaultgatewayaddress`](#dsc_defaultgatewayaddress): The DSC DefaultGatewayAddress resource type. Automatically generated from version 9.0.0
* [`dsc_dnsclientglobalsetting`](#dsc_dnsclientglobalsetting): The DSC DnsClientGlobalSetting resource type. Automatically generated from version 9.0.0
* [`dsc_dnsconnectionsuffix`](#dsc_dnsconnectionsuffix): The DSC DnsConnectionSuffix resource type. Automatically generated from version 9.0.0
* [`dsc_dnsserveraddress`](#dsc_dnsserveraddress): The DSC DnsServerAddress resource type. Automatically generated from version 9.0.0
* [`dsc_firewall`](#dsc_firewall): The DSC Firewall resource type. Automatically generated from version 9.0.0
* [`dsc_firewallprofile`](#dsc_firewallprofile): The DSC FirewallProfile resource type. Automatically generated from version 9.0.0
* [`dsc_hostsfile`](#dsc_hostsfile): The DSC HostsFile resource type. Automatically generated from version 9.0.0
* [`dsc_ipaddress`](#dsc_ipaddress): The DSC IPAddress resource type. Automatically generated from version 9.0.0
* [`dsc_ipaddressoption`](#dsc_ipaddressoption): The DSC IPAddressOption resource type. Automatically generated from version 9.0.0
* [`dsc_netadapteradvancedproperty`](#dsc_netadapteradvancedproperty): The DSC NetAdapterAdvancedProperty resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterbinding`](#dsc_netadapterbinding): The DSC NetAdapterBinding resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterlso`](#dsc_netadapterlso): The DSC NetAdapterLso resource type. Automatically generated from version 9.0.0
* [`dsc_netadaptername`](#dsc_netadaptername): The DSC NetAdapterName resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterrdma`](#dsc_netadapterrdma): The DSC NetAdapterRdma resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterrsc`](#dsc_netadapterrsc): The DSC NetAdapterRsc resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterrss`](#dsc_netadapterrss): The DSC NetAdapterRss resource type. Automatically generated from version 9.0.0
* [`dsc_netadapterstate`](#dsc_netadapterstate): The DSC NetAdapterState resource type. Automatically generated from version 9.0.0
* [`dsc_netbios`](#dsc_netbios): The DSC NetBios resource type. Automatically generated from version 9.0.0
* [`dsc_netconnectionprofile`](#dsc_netconnectionprofile): The DSC NetConnectionProfile resource type. Automatically generated from version 9.0.0
* [`dsc_netipinterface`](#dsc_netipinterface): The DSC NetIPInterface resource type. Automatically generated from version 9.0.0
* [`dsc_networkteam`](#dsc_networkteam): The DSC NetworkTeam resource type. Automatically generated from version 9.0.0
* [`dsc_networkteaminterface`](#dsc_networkteaminterface): The DSC NetworkTeamInterface resource type. Automatically generated from version 9.0.0
* [`dsc_proxysettings`](#dsc_proxysettings): The DSC ProxySettings resource type. Automatically generated from version 9.0.0
* [`dsc_route`](#dsc_route): The DSC Route resource type. Automatically generated from version 9.0.0
* [`dsc_waitfornetworkteam`](#dsc_waitfornetworkteam): The DSC WaitForNetworkTeam resource type. Automatically generated from version 9.0.0
* [`dsc_winsserveraddress`](#dsc_winsserveraddress): The DSC WinsServerAddress resource type. Automatically generated from version 9.0.0
* [`dsc_winssetting`](#dsc_winssetting): The DSC WinsSetting resource type. Automatically generated from version 9.0.0

## Resource types

### <a name="dsc_defaultgatewayaddress"></a>`dsc_defaultgatewayaddress`

The DSC DefaultGatewayAddress resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_defaultgatewayaddress` type.

##### `dsc_address`

Data type: `Optional[String]`

The desired default gateway address - if not provided default gateway will be removed.

#### Parameters

The following parameters are available in the `dsc_defaultgatewayaddress` type.

* [`dsc_addressfamily`](#-dsc_defaultgatewayaddress--dsc_addressfamily)
* [`dsc_interfacealias`](#-dsc_defaultgatewayaddress--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_defaultgatewayaddress--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_defaultgatewayaddress--dsc_timeout)
* [`name`](#-dsc_defaultgatewayaddress--name)
* [`validation_mode`](#-dsc_defaultgatewayaddress--validation_mode)

##### <a name="-dsc_defaultgatewayaddress--dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6']`

IP address family.

##### <a name="-dsc_defaultgatewayaddress--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the default gateway address is set.

##### <a name="-dsc_defaultgatewayaddress--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_defaultgatewayaddress--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_defaultgatewayaddress--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_defaultgatewayaddress--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dnsclientglobalsetting"></a>`dsc_dnsclientglobalsetting`

The DSC DnsClientGlobalSetting resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_dnsclientglobalsetting` type.

##### `dsc_devolutionlevel`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of labels up to which devolution should occur.

##### `dsc_suffixsearchlist`

Data type: `Optional[Array[String]]`

Specifies a list of global suffixes that can be used in the specified order by the DNS client for resolving the IP address of the computer name.

##### `dsc_usedevolution`

Data type: `Optional[Boolean]`

Specifies that devolution is activated.

#### Parameters

The following parameters are available in the `dsc_dnsclientglobalsetting` type.

* [`dsc_issingleinstance`](#-dsc_dnsclientglobalsetting--dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#-dsc_dnsclientglobalsetting--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_dnsclientglobalsetting--dsc_timeout)
* [`name`](#-dsc_dnsclientglobalsetting--name)
* [`validation_mode`](#-dsc_dnsclientglobalsetting--validation_mode)

##### <a name="-dsc_dnsclientglobalsetting--dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes', 'yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="-dsc_dnsclientglobalsetting--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_dnsclientglobalsetting--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_dnsclientglobalsetting--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_dnsclientglobalsetting--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dnsconnectionsuffix"></a>`dsc_dnsconnectionsuffix`

The DSC DnsConnectionSuffix resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_dnsconnectionsuffix` type.

##### `dsc_connectionspecificsuffix`

Data type: `String`

DNS connection-specific suffix to assign to the network interface.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Ensure that the network interface connection-specific suffix is present or not.

##### `dsc_registerthisconnectionsaddress`

Data type: `Optional[Boolean]`

Specifies that the IP address for this connection is to be registered.

##### `dsc_usesuffixwhenregistering`

Data type: `Optional[Boolean]`

Specifies that this host name and the connection specific suffix for this connection are to be registered.

#### Parameters

The following parameters are available in the `dsc_dnsconnectionsuffix` type.

* [`dsc_interfacealias`](#-dsc_dnsconnectionsuffix--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_dnsconnectionsuffix--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_dnsconnectionsuffix--dsc_timeout)
* [`name`](#-dsc_dnsconnectionsuffix--name)
* [`validation_mode`](#-dsc_dnsconnectionsuffix--validation_mode)

##### <a name="-dsc_dnsconnectionsuffix--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the DNS server address is set.

##### <a name="-dsc_dnsconnectionsuffix--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_dnsconnectionsuffix--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_dnsconnectionsuffix--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_dnsconnectionsuffix--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_dnsserveraddress"></a>`dsc_dnsserveraddress`

The DSC DnsServerAddress resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_dnsserveraddress` type.

##### `dsc_address`

Data type: `Optional[Array[String]]`

The desired DNS Server address(es). Exclude to enable DHCP.

#### Parameters

The following parameters are available in the `dsc_dnsserveraddress` type.

* [`dsc_addressfamily`](#-dsc_dnsserveraddress--dsc_addressfamily)
* [`dsc_interfacealias`](#-dsc_dnsserveraddress--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_dnsserveraddress--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_dnsserveraddress--dsc_timeout)
* [`dsc_validate`](#-dsc_dnsserveraddress--dsc_validate)
* [`name`](#-dsc_dnsserveraddress--name)
* [`validation_mode`](#-dsc_dnsserveraddress--validation_mode)

##### <a name="-dsc_dnsserveraddress--dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6']`

IP address family.

##### <a name="-dsc_dnsserveraddress--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the DNS server address is set.

##### <a name="-dsc_dnsserveraddress--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_dnsserveraddress--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_dnsserveraddress--dsc_validate"></a>`dsc_validate`

Data type: `Optional[Boolean]`

Requires that the DNS Server addresses be validated if they are updated. It will cause the resource to throw a 'A
general error occurred that is not covered by a more specific error code.' error if set to True and specified DNS
Servers are not accessible.

##### <a name="-dsc_dnsserveraddress--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_dnsserveraddress--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_firewall"></a>`dsc_firewall`

The DSC Firewall resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_firewall` type.

##### `dsc_action`

Data type: `Optional[Enum['NotConfigured', 'notconfigured', 'Allow', 'allow', 'Block', 'block']]`

Allow or Block the supplied configuration.

##### `dsc_authentication`

Data type: `Optional[Enum['NotRequired', 'notrequired', 'Required', 'required', 'NoEncap', 'noencap']]`

Specifies that authentication is required on firewall rules.

##### `dsc_description`

Data type: `Optional[String]`

Documentation for the Rule.

##### `dsc_direction`

Data type: `Optional[Enum['Inbound', 'inbound', 'Outbound', 'outbound']]`

Direction of the connection.

##### `dsc_displaygroup`

Data type: `Optional[String]`

The current value of the Display Group of the Firewall Rule.

##### `dsc_displayname`

Data type: `Optional[String]`

Localized, user-facing name of the Firewall Rule being created.

##### `dsc_dynamictransport`

Data type: `Optional[Enum['Any', 'any', 'ProximityApps', 'proximityapps', 'ProximitySharing', 'proximitysharing', 'WifiDirectPrinting', 'wifidirectprinting', 'WifiDirectDisplay', 'wifidirectdisplay', 'WifiDirectDevices', 'wifidirectdevices']]`

Specifies a dynamic transport.

##### `dsc_edgetraversalpolicy`

Data type: `Optional[Enum['Block', 'block', 'Allow', 'allow', 'DeferToUser', 'defertouser', 'DeferToApp', 'defertoapp']]`

Specifies that matching firewall rules of the indicated edge traversal policy are created.

##### `dsc_enabled`

Data type: `Optional[Enum['True', 'true', 'False', 'false']]`

Enable or disable the supplied configuration.

##### `dsc_encryption`

Data type: `Optional[Enum['NotRequired', 'notrequired', 'Required', 'required', 'Dynamic', 'dynamic']]`

Specifies that encryption in authentication is required on firewall rules.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Ensure the presence/absence of the resource.

##### `dsc_group`

Data type: `Optional[String]`

Name of the Firewall Group where we want to put the Firewall Rule.

##### `dsc_icmptype`

Data type: `Optional[Array[String]]`

Specifies the ICMP type codes.

##### `dsc_interfacealias`

Data type: `Optional[Array[String]]`

Specifies the alias of the interface that applies to the traffic.

##### `dsc_interfacetype`

Data type: `Optional[Enum['Any', 'any', 'Wired', 'wired', 'Wireless', 'wireless', 'RemoteAccess', 'remoteaccess']]`

Specifies that only network connections made through the indicated interface types are subject to the requirements of this rule.

##### `dsc_localaddress`

Data type: `Optional[Array[String]]`

Specifies that network packets with matching IP addresses match this rule.

##### `dsc_localonlymapping`

Data type: `Optional[Boolean]`

Indicates that matching firewall rules of the indicated value are created.

##### `dsc_localport`

Data type: `Optional[Array[String]]`

Local Port used for the filter.

##### `dsc_localuser`

Data type: `Optional[String]`

Specifies the principals to which network traffic this firewall rule applies.

##### `dsc_loosesourcemapping`

Data type: `Optional[Boolean]`

Indicates that matching firewall rules of the indicated value are created.

##### `dsc_overrideblockrules`

Data type: `Optional[Boolean]`

Indicates that matching network traffic that would otherwise be blocked are allowed.

##### `dsc_owner`

Data type: `Optional[String]`

Specifies that matching firewall rules of the indicated owner are created.

##### `dsc_package`

Data type: `Optional[String]`

Specifies the Windows Store application to which the firewall rule applies.

##### `dsc_platform`

Data type: `Optional[Array[String]]`

Specifies which version of Windows the associated rule applies.

##### `dsc_profile`

Data type: `Optional[Array[String]]`

Specifies one or more profiles to which the rule is assigned.

##### `dsc_program`

Data type: `Optional[String]`

Path and file name of the program for which the rule is applied.

##### `dsc_protocol`

Data type: `Optional[String]`

Specific Protocol for filter. Specified by name, number, or range.

##### `dsc_remoteaddress`

Data type: `Optional[Array[String]]`

Specifies that network packets with matching IP addresses match this rule.

##### `dsc_remotemachine`

Data type: `Optional[String]`

Specifies that matching IPsec rules of the indicated computer accounts are created.

##### `dsc_remoteport`

Data type: `Optional[Array[String]]`

Specific Port used for filter. Specified by port number, range, or keyword

##### `dsc_remoteuser`

Data type: `Optional[String]`

Specifies that matching IPsec rules of the indicated user accounts are created.

##### `dsc_service`

Data type: `Optional[String]`

Specifies the short name of a Windows service to which the firewall rule applies.

#### Parameters

The following parameters are available in the `dsc_firewall` type.

* [`dsc_name`](#-dsc_firewall--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_firewall--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_firewall--dsc_timeout)
* [`name`](#-dsc_firewall--name)
* [`validation_mode`](#-dsc_firewall--validation_mode)

##### <a name="-dsc_firewall--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Name of the Firewall Rule.

##### <a name="-dsc_firewall--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_firewall--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_firewall--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_firewall--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_firewallprofile"></a>`dsc_firewallprofile`

The DSC FirewallProfile resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_firewallprofile` type.

##### `dsc_allowinboundrules`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that the firewall blocks inbound traffic.

##### `dsc_allowlocalfirewallrules`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that the local firewall rules should be merged into the effective policy along with Group Policy settings.

##### `dsc_allowlocalipsecrules`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that the local IPsec rules should be merged into the effective policy along with Group Policy settings.

##### `dsc_allowunicastresponsetomulticast`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Allows unicast responses to multi-cast traffic.

##### `dsc_allowuserapps`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that traffic from local user applications is allowed through the firewall.

##### `dsc_allowuserports`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that traffic is allowed through local user ports.

##### `dsc_defaultinboundaction`

Data type: `Optional[Enum['Block', 'block', 'Allow', 'allow', 'NotConfigured', 'notconfigured']]`

Specifies how to filter inbound traffic.

##### `dsc_defaultoutboundaction`

Data type: `Optional[Enum['Block', 'block', 'Allow', 'allow', 'NotConfigured', 'notconfigured']]`

Specifies how to filter outbound traffic.

##### `dsc_disabledinterfacealiases`

Data type: `Optional[Array[String]]`

Specifies a list of interfaces on which firewall settings are excluded.

##### `dsc_enabled`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies that devolution is activated.

##### `dsc_enablestealthmodeforipsec`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Enables stealth mode for IPsec traffic.

##### `dsc_logallowed`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies how to log the allowed packets in the location specified by the LogFileName parameter.

##### `dsc_logblocked`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies how to log the dropped packets in the location specified by the LogFileName parameter.

##### `dsc_logfilename`

Data type: `Optional[String]`

Specifies the path and filename of the file to which Windows Server writes log entries.

##### `dsc_logignored`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Specifies how to log the ignored packets in the location specified by the LogFileName parameter.

##### `dsc_logmaxsizekilobytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the maximum file size of the log, in kilobytes. The acceptable values for this parameter are: 1 through 32767.

##### `dsc_notifyonlisten`

Data type: `Optional[Enum['True', 'true', 'False', 'false', 'NotConfigured', 'notconfigured']]`

Allows the notification of listening for inbound connections by a service.

#### Parameters

The following parameters are available in the `dsc_firewallprofile` type.

* [`dsc_name`](#-dsc_firewallprofile--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_firewallprofile--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_firewallprofile--dsc_timeout)
* [`name`](#-dsc_firewallprofile--name)
* [`validation_mode`](#-dsc_firewallprofile--validation_mode)

##### <a name="-dsc_firewallprofile--dsc_name"></a>`dsc_name`

namevar

Data type: `Enum['Domain', 'domain', 'Public', 'public', 'Private', 'private']`

The name of the firewall profile to configure.

##### <a name="-dsc_firewallprofile--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_firewallprofile--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_firewallprofile--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_firewallprofile--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_hostsfile"></a>`dsc_hostsfile`

The DSC HostsFile resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_hostsfile` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the hosts file entry should be created or deleted.

##### `dsc_ipaddress`

Data type: `Optional[String]`

Specifies the IP Address that should be mapped to the host name.

#### Parameters

The following parameters are available in the `dsc_hostsfile` type.

* [`dsc_hostname`](#-dsc_hostsfile--dsc_hostname)
* [`dsc_psdscrunascredential`](#-dsc_hostsfile--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_hostsfile--dsc_timeout)
* [`name`](#-dsc_hostsfile--name)
* [`validation_mode`](#-dsc_hostsfile--validation_mode)

##### <a name="-dsc_hostsfile--dsc_hostname"></a>`dsc_hostname`

namevar

Data type: `String`

Specifies the name of the computer that will be mapped to an IP address.

##### <a name="-dsc_hostsfile--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_hostsfile--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_hostsfile--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_hostsfile--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_ipaddress"></a>`dsc_ipaddress`

The DSC IPAddress resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_ipaddress` type.

##### `dsc_ipaddress`

Data type: `Optional[Array[String]]`

The desired IP address, optionally including prefix length using CIDR notation.

##### `dsc_keepexistingaddress`

Data type: `Optional[Boolean]`

Indicates whether or not existing IP addresses on an interface will be retained.

#### Parameters

The following parameters are available in the `dsc_ipaddress` type.

* [`dsc_addressfamily`](#-dsc_ipaddress--dsc_addressfamily)
* [`dsc_interfacealias`](#-dsc_ipaddress--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_ipaddress--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_ipaddress--dsc_timeout)
* [`name`](#-dsc_ipaddress--name)
* [`validation_mode`](#-dsc_ipaddress--validation_mode)

##### <a name="-dsc_ipaddress--dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6']`

IP address family.

##### <a name="-dsc_ipaddress--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the IP address should be set.

##### <a name="-dsc_ipaddress--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_ipaddress--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_ipaddress--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_ipaddress--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_ipaddressoption"></a>`dsc_ipaddressoption`

The DSC IPAddressOption resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_ipaddressoption` type.

##### `dsc_skipassource`

Data type: `Optional[Boolean]`

Skip as source option of the ip address.

#### Parameters

The following parameters are available in the `dsc_ipaddressoption` type.

* [`dsc_ipaddress`](#-dsc_ipaddressoption--dsc_ipaddress)
* [`dsc_psdscrunascredential`](#-dsc_ipaddressoption--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_ipaddressoption--dsc_timeout)
* [`name`](#-dsc_ipaddressoption--name)
* [`validation_mode`](#-dsc_ipaddressoption--validation_mode)

##### <a name="-dsc_ipaddressoption--dsc_ipaddress"></a>`dsc_ipaddress`

namevar

Data type: `String`

The target IP address, must already be configured on the system.

##### <a name="-dsc_ipaddressoption--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_ipaddressoption--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_ipaddressoption--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_ipaddressoption--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapteradvancedproperty"></a>`dsc_netadapteradvancedproperty`

The DSC NetAdapterAdvancedProperty resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapteradvancedproperty` type.

##### `dsc_displayvalue`

Data type: `Optional[String]`

Output Display value of selected RegistryKeyword.

##### `dsc_registryvalue`

Data type: `String`

Specifies the value of the registry keyword.

#### Parameters

The following parameters are available in the `dsc_netadapteradvancedproperty` type.

* [`dsc_networkadaptername`](#-dsc_netadapteradvancedproperty--dsc_networkadaptername)
* [`dsc_psdscrunascredential`](#-dsc_netadapteradvancedproperty--dsc_psdscrunascredential)
* [`dsc_registrykeyword`](#-dsc_netadapteradvancedproperty--dsc_registrykeyword)
* [`dsc_timeout`](#-dsc_netadapteradvancedproperty--dsc_timeout)
* [`name`](#-dsc_netadapteradvancedproperty--name)
* [`validation_mode`](#-dsc_netadapteradvancedproperty--validation_mode)

##### <a name="-dsc_netadapteradvancedproperty--dsc_networkadaptername"></a>`dsc_networkadaptername`

namevar

Data type: `String`

Specifies the name of the network adapter to set the advanced property for.

##### <a name="-dsc_netadapteradvancedproperty--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapteradvancedproperty--dsc_registrykeyword"></a>`dsc_registrykeyword`

namevar

Data type: `String`

Specifies the registry keyword that should be in desired state.

##### <a name="-dsc_netadapteradvancedproperty--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapteradvancedproperty--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapteradvancedproperty--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterbinding"></a>`dsc_netadapterbinding`

The DSC NetAdapterBinding resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterbinding` type.

##### `dsc_currentstate`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled', 'Mixed', 'mixed']]`

Returns the current state of the component ID for the Interfaces.

##### `dsc_state`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies if the component ID for the Interface should be Enabled or Disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterbinding` type.

* [`dsc_componentid`](#-dsc_netadapterbinding--dsc_componentid)
* [`dsc_interfacealias`](#-dsc_netadapterbinding--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_netadapterbinding--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterbinding--dsc_timeout)
* [`name`](#-dsc_netadapterbinding--name)
* [`validation_mode`](#-dsc_netadapterbinding--validation_mode)

##### <a name="-dsc_netadapterbinding--dsc_componentid"></a>`dsc_componentid`

namevar

Data type: `String`

Specifies the underlying name of the transport or filter in the following form - ms_xxxx, such as ms_tcpip.

##### <a name="-dsc_netadapterbinding--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface. Supports the use of '*'.

##### <a name="-dsc_netadapterbinding--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterbinding--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterbinding--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterbinding--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterlso"></a>`dsc_netadapterlso`

The DSC NetAdapterLso resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterlso` type.

##### `dsc_state`

Data type: `Boolean`

Specifies whether LSO should be enabled or disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterlso` type.

* [`dsc_name`](#-dsc_netadapterlso--dsc_name)
* [`dsc_protocol`](#-dsc_netadapterlso--dsc_protocol)
* [`dsc_psdscrunascredential`](#-dsc_netadapterlso--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterlso--dsc_timeout)
* [`name`](#-dsc_netadapterlso--name)
* [`validation_mode`](#-dsc_netadapterlso--validation_mode)

##### <a name="-dsc_netadapterlso--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter.

##### <a name="-dsc_netadapterlso--dsc_protocol"></a>`dsc_protocol`

namevar

Data type: `Enum['V1IPv4', 'v1ipv4', 'IPv4', 'ipv4', 'IPv6', 'ipv6']`

Specifies which protocol to make changes to.

##### <a name="-dsc_netadapterlso--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterlso--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterlso--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterlso--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadaptername"></a>`dsc_netadaptername`

The DSC NetAdapterName resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadaptername` type.

##### `dsc_driverdescription`

Data type: `Optional[String]`

This is the driver description of the network adapter.

##### `dsc_ignoremultiplematchingadapters`

Data type: `Optional[Boolean]`

This switch will suppress an error occurring if more than one matching adapter matches the parameters passed.

##### `dsc_interfacedescription`

Data type: `Optional[String]`

This is the interface description of the network adapter to find.

##### `dsc_interfaceguid`

Data type: `Optional[String]`

This is the interface GUID of the network adapter to find.

##### `dsc_interfaceindex`

Data type: `Optional[Integer[0, 4294967295]]`

This is the interface index of the network adapter to find.

##### `dsc_interfacenumber`

Data type: `Optional[Integer[0, 4294967295]]`

This is the interface number of the network adapter if more than one are returned by the parameters.

##### `dsc_macaddress`

Data type: `Optional[String]`

This is the MAC address of the network adapter to find.

##### `dsc_name`

Data type: `Optional[String]`

This is the name of the network adapter to find.

##### `dsc_physicalmediatype`

Data type: `Optional[String]`

This is the media type of the network adapter to find.

##### `dsc_status`

Data type: `Optional[Enum['Up', 'up', 'Disconnected', 'disconnected', 'Disabled', 'disabled']]`

This is the status of the network adapter to find.

#### Parameters

The following parameters are available in the `dsc_netadaptername` type.

* [`dsc_newname`](#-dsc_netadaptername--dsc_newname)
* [`dsc_psdscrunascredential`](#-dsc_netadaptername--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadaptername--dsc_timeout)
* [`name`](#-dsc_netadaptername--name)
* [`validation_mode`](#-dsc_netadaptername--validation_mode)

##### <a name="-dsc_netadaptername--dsc_newname"></a>`dsc_newname`

namevar

Data type: `String`

Specifies the new name of the network adapter.

##### <a name="-dsc_netadaptername--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadaptername--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadaptername--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadaptername--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterrdma"></a>`dsc_netadapterrdma`

The DSC NetAdapterRdma resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterrdma` type.

##### `dsc_enabled`

Data type: `Optional[Boolean]`

Specifies if the RDMA configuration should be enabled or disabled. Defaults to $true.

#### Parameters

The following parameters are available in the `dsc_netadapterrdma` type.

* [`dsc_name`](#-dsc_netadapterrdma--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_netadapterrdma--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterrdma--dsc_timeout)
* [`name`](#-dsc_netadapterrdma--name)
* [`validation_mode`](#-dsc_netadapterrdma--validation_mode)

##### <a name="-dsc_netadapterrdma--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter for which RDMA needs to be configured.

##### <a name="-dsc_netadapterrdma--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterrdma--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterrdma--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterrdma--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterrsc"></a>`dsc_netadapterrsc`

The DSC NetAdapterRsc resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterrsc` type.

##### `dsc_protocol`

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6', 'All', 'all']`

Specifies which protocol to make changes to.

##### `dsc_state`

Data type: `Boolean`

Specifies whether RSC should be enabled or disabled.

##### `dsc_stateipv4`

Data type: `Optional[String]`

Returns the current state of RSC for IPv4

##### `dsc_stateipv6`

Data type: `Optional[String]`

Returns the current state of RSC for IPv6

#### Parameters

The following parameters are available in the `dsc_netadapterrsc` type.

* [`dsc_name`](#-dsc_netadapterrsc--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_netadapterrsc--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterrsc--dsc_timeout)
* [`name`](#-dsc_netadapterrsc--name)
* [`validation_mode`](#-dsc_netadapterrsc--validation_mode)

##### <a name="-dsc_netadapterrsc--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the Name of network adapter.

##### <a name="-dsc_netadapterrsc--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterrsc--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterrsc--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterrsc--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterrss"></a>`dsc_netadapterrss`

The DSC NetAdapterRss resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterrss` type.

##### `dsc_enabled`

Data type: `Boolean`

Specifies whether RSS should be enabled or disabled.

#### Parameters

The following parameters are available in the `dsc_netadapterrss` type.

* [`dsc_name`](#-dsc_netadapterrss--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_netadapterrss--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterrss--dsc_timeout)
* [`name`](#-dsc_netadapterrss--name)
* [`validation_mode`](#-dsc_netadapterrss--validation_mode)

##### <a name="-dsc_netadapterrss--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the Name of network adapter.

##### <a name="-dsc_netadapterrss--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterrss--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterrss--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterrss--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netadapterstate"></a>`dsc_netadapterstate`

The DSC NetAdapterState resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netadapterstate` type.

##### `dsc_state`

Data type: `Enum['Enabled', 'enabled', 'Disabled', 'disabled']`

Specifies the desired state of the network adapter

#### Parameters

The following parameters are available in the `dsc_netadapterstate` type.

* [`dsc_name`](#-dsc_netadapterstate--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_netadapterstate--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netadapterstate--dsc_timeout)
* [`name`](#-dsc_netadapterstate--name)
* [`validation_mode`](#-dsc_netadapterstate--validation_mode)

##### <a name="-dsc_netadapterstate--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of network adapter.

##### <a name="-dsc_netadapterstate--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netadapterstate--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netadapterstate--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netadapterstate--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netbios"></a>`dsc_netbios`

The DSC NetBios resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netbios` type.

##### `dsc_setting`

Data type: `Enum['Default', 'default', 'Enable', 'enable', 'Disable', 'disable']`

Specifies if NetBIOS should be enabled or disabled or obtained from the DHCP server (Default). If static IP, Enable NetBIOS.

#### Parameters

The following parameters are available in the `dsc_netbios` type.

* [`dsc_interfacealias`](#-dsc_netbios--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_netbios--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netbios--dsc_timeout)
* [`name`](#-dsc_netbios--name)
* [`validation_mode`](#-dsc_netbios--validation_mode)

##### <a name="-dsc_netbios--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface. Supports the use of '*' and '%'

##### <a name="-dsc_netbios--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netbios--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netbios--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netbios--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netconnectionprofile"></a>`dsc_netconnectionprofile`

The DSC NetConnectionProfile resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netconnectionprofile` type.

##### `dsc_ipv4connectivity`

Data type: `Optional[Enum['Disconnected', 'disconnected', 'NoTraffic', 'notraffic', 'Subnet', 'subnet', 'LocalNetwork', 'localnetwork', 'Internet', 'internet']]`

Sets the Network Category for the interface.

##### `dsc_ipv6connectivity`

Data type: `Optional[Enum['Disconnected', 'disconnected', 'NoTraffic', 'notraffic', 'Subnet', 'subnet', 'LocalNetwork', 'localnetwork', 'Internet', 'internet']]`

Specifies the IPv4 Connection Value.

##### `dsc_networkcategory`

Data type: `Optional[Enum['Public', 'public', 'Private', 'private']]`

Specifies the IPv6 Connection Value.

#### Parameters

The following parameters are available in the `dsc_netconnectionprofile` type.

* [`dsc_interfacealias`](#-dsc_netconnectionprofile--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_netconnectionprofile--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netconnectionprofile--dsc_timeout)
* [`name`](#-dsc_netconnectionprofile--name)
* [`validation_mode`](#-dsc_netconnectionprofile--validation_mode)

##### <a name="-dsc_netconnectionprofile--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias for the Interface that is being changed.

##### <a name="-dsc_netconnectionprofile--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netconnectionprofile--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netconnectionprofile--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netconnectionprofile--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_netipinterface"></a>`dsc_netipinterface`

The DSC NetIPInterface resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_netipinterface` type.

##### `dsc_advertisedefaultroute`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the default router advertisement for an interface.

##### `dsc_advertising`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the router advertisement value for the IP interface.

##### `dsc_automaticmetric`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the value for automatic metric calculation.

##### `dsc_dhcp`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the Dynamic Host Configuration Protocol (DHCP) value for an IP interface.

##### `dsc_directedmacwolpattern`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the wake-up packet value for an IP interface.

##### `dsc_ecnmarking`

Data type: `Optional[Enum['Disabled', 'disabled', 'UseEct1', 'useect1', 'UseEct0', 'useect0', 'AppDecide', 'appdecide']]`

Specifies the value for Explicit Congestion Notification (ECN) marking.

##### `dsc_forcearpndwolpattern`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the Wake On LAN (WOL) value for the IP interface.

##### `dsc_forwarding`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the packet forwarding value for the IP interface.

##### `dsc_ignoredefaultroutes`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies a value for Default Route advertisements.

##### `dsc_interfacemetric`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the metric for an IP interface.

##### `dsc_managedaddressconfiguration`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the value for managed address configuration.

##### `dsc_neighborunreachabilitydetection`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the value for Neighbor Unreachability Detection (NUD).

##### `dsc_nlmtu`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the network layer Maximum Transmission Unit (MTU) value, in bytes, for an IP interface.

##### `dsc_otherstatefulconfiguration`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the value for configuration other than addresses.

##### `dsc_routerdiscovery`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled', 'ControlledByDHCP', 'controlledbydhcp']]`

Specifies the value for router discovery for an IP interface.

##### `dsc_weakhostreceive`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the receive value for a weak host model.

##### `dsc_weakhostsend`

Data type: `Optional[Enum['Enabled', 'enabled', 'Disabled', 'disabled']]`

Specifies the send value for a weak host model.

#### Parameters

The following parameters are available in the `dsc_netipinterface` type.

* [`dsc_addressfamily`](#-dsc_netipinterface--dsc_addressfamily)
* [`dsc_interfacealias`](#-dsc_netipinterface--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_netipinterface--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_netipinterface--dsc_timeout)
* [`name`](#-dsc_netipinterface--name)
* [`validation_mode`](#-dsc_netipinterface--validation_mode)

##### <a name="-dsc_netipinterface--dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6']`

IP address family on the interface to configure.

##### <a name="-dsc_netipinterface--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface to configure.

##### <a name="-dsc_netipinterface--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_netipinterface--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_netipinterface--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_netipinterface--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_networkteam"></a>`dsc_networkteam`

The DSC NetworkTeam resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_networkteam` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the network team should be created or deleted. Defaults to 'Present'.

##### `dsc_loadbalancingalgorithm`

Data type: `Optional[Enum['Dynamic', 'dynamic', 'HyperVPort', 'hypervport', 'IPAddresses', 'ipaddresses', 'MacAddresses', 'macaddresses', 'TransportPorts', 'transportports']]`

Specifies the load balancing algorithm for the network team.

##### `dsc_teamingmode`

Data type: `Optional[Enum['SwitchIndependent', 'switchindependent', 'LACP', 'lacp', 'Static', 'static']]`

Specifies the teaming mode configuration.

##### `dsc_teammembers`

Data type: `Array[String]`

Specifies the network interfaces that should be a part of the network team. This is a comma-separated list.

#### Parameters

The following parameters are available in the `dsc_networkteam` type.

* [`dsc_name`](#-dsc_networkteam--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_networkteam--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_networkteam--dsc_timeout)
* [`name`](#-dsc_networkteam--name)
* [`validation_mode`](#-dsc_networkteam--validation_mode)

##### <a name="-dsc_networkteam--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the network team to create.

##### <a name="-dsc_networkteam--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_networkteam--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_networkteam--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_networkteam--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_networkteaminterface"></a>`dsc_networkteaminterface`

The DSC NetworkTeamInterface resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_networkteaminterface` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if the network team interface should be created or deleted. Defaults to 'Present'.

##### `dsc_teamname`

Data type: `String`

Specifies the name of the network team on which this particular interface should exist.

##### `dsc_vlanid`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies VLAN ID to be set on network team interface.

#### Parameters

The following parameters are available in the `dsc_networkteaminterface` type.

* [`dsc_name`](#-dsc_networkteaminterface--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_networkteaminterface--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_networkteaminterface--dsc_timeout)
* [`name`](#-dsc_networkteaminterface--name)
* [`validation_mode`](#-dsc_networkteaminterface--validation_mode)

##### <a name="-dsc_networkteaminterface--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the network team interface to create.

##### <a name="-dsc_networkteaminterface--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_networkteaminterface--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_networkteaminterface--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_networkteaminterface--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_proxysettings"></a>`dsc_proxysettings`

The DSC ProxySettings resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_proxysettings` type.

##### `dsc_autoconfigurl`

Data type: `Optional[String]`

The URL of the automatic configuration script to specify the proxy settings. Should be specified if 'EnableAutoConfiguration' is 'True'.

##### `dsc_connectiontype`

Data type: `Optional[Enum['All', 'all', 'Default', 'default', 'Legacy', 'legacy']]`

Defines if the proxy settings should be configured for default connections, legacy connections or all connections. Defaults to 'All'.

##### `dsc_enableautoconfiguration`

Data type: `Optional[Boolean]`

Use automatic configuration script for specifying proxy settings. Defaults to 'False'.

##### `dsc_enableautodetection`

Data type: `Optional[Boolean]`

Enable automatic detection of the proxy settings. Defaults to 'False'.

##### `dsc_enablemanualproxy`

Data type: `Optional[Boolean]`

Use manual proxy server settings. Defaults to 'False'.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies if proxy settings should be set. Defaults to 'Present'.

##### `dsc_proxyserver`

Data type: `Optional[String]`

The address and port of the manual proxy server to use. Should be specified if 'EnableManualProxy' is 'True'.

##### `dsc_proxyserverbypasslocal`

Data type: `Optional[Boolean]`

Bypass proxy server for local addresses. Defaults to 'False'.

##### `dsc_proxyserverexceptions`

Data type: `Optional[Array[String]]`

Bypass proxy server for addresses starting with addresses in this list.

#### Parameters

The following parameters are available in the `dsc_proxysettings` type.

* [`dsc_psdscrunascredential`](#-dsc_proxysettings--dsc_psdscrunascredential)
* [`dsc_target`](#-dsc_proxysettings--dsc_target)
* [`dsc_timeout`](#-dsc_proxysettings--dsc_timeout)
* [`name`](#-dsc_proxysettings--name)
* [`validation_mode`](#-dsc_proxysettings--validation_mode)

##### <a name="-dsc_proxysettings--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_proxysettings--dsc_target"></a>`dsc_target`

namevar

Data type: `Enum['LocalMachine', 'localmachine', 'CurrentUser', 'currentuser']`

Specifies if the proxy settings should be set for the LocalMachine or for the CurrentUser. Defaults to 'LocalMachine'.

##### <a name="-dsc_proxysettings--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_proxysettings--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_proxysettings--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_route"></a>`dsc_route`

The DSC Route resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_route` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether the route should exist. Defaults to 'Present'.

##### `dsc_preferredlifetime`

Data type: `Optional[Float]`

Specifies a preferred lifetime in seconds of an IP route.

##### `dsc_publish`

Data type: `Optional[Enum['No', 'no', 'Yes', 'yes', 'Age', 'age']]`

Specifies the publish setting of an IP route. Defaults to 'No'.

##### `dsc_routemetric`

Data type: `Optional[Integer[0, 65535]]`

Specifies an integer route metric for an IP route. Defaults to 256.

#### Parameters

The following parameters are available in the `dsc_route` type.

* [`dsc_addressfamily`](#-dsc_route--dsc_addressfamily)
* [`dsc_destinationprefix`](#-dsc_route--dsc_destinationprefix)
* [`dsc_interfacealias`](#-dsc_route--dsc_interfacealias)
* [`dsc_nexthop`](#-dsc_route--dsc_nexthop)
* [`dsc_psdscrunascredential`](#-dsc_route--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_route--dsc_timeout)
* [`name`](#-dsc_route--name)
* [`validation_mode`](#-dsc_route--validation_mode)

##### <a name="-dsc_route--dsc_addressfamily"></a>`dsc_addressfamily`

namevar

Data type: `Enum['IPv4', 'ipv4', 'IPv6', 'ipv6']`

Specifies the IP address family.

##### <a name="-dsc_route--dsc_destinationprefix"></a>`dsc_destinationprefix`

namevar

Data type: `String`

Specifies a destination prefix of an IP route. A destination prefix consists of an IP address prefix and a prefix
length, separated by a slash (/).

##### <a name="-dsc_route--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Specifies the alias of a network interface.

##### <a name="-dsc_route--dsc_nexthop"></a>`dsc_nexthop`

namevar

Data type: `String`

Specifies the next hop for the IP route.

##### <a name="-dsc_route--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_route--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_route--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_route--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_waitfornetworkteam"></a>`dsc_waitfornetworkteam`

The DSC WaitForNetworkTeam resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_waitfornetworkteam` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to loop the retry interval while waiting for the network team.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of seconds to wait for the network team to become available.

#### Parameters

The following parameters are available in the `dsc_waitfornetworkteam` type.

* [`dsc_name`](#-dsc_waitfornetworkteam--dsc_name)
* [`dsc_psdscrunascredential`](#-dsc_waitfornetworkteam--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_waitfornetworkteam--dsc_timeout)
* [`name`](#-dsc_waitfornetworkteam--name)
* [`validation_mode`](#-dsc_waitfornetworkteam--validation_mode)

##### <a name="-dsc_waitfornetworkteam--dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the network team to wait for.

##### <a name="-dsc_waitfornetworkteam--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_waitfornetworkteam--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_waitfornetworkteam--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_waitfornetworkteam--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_winsserveraddress"></a>`dsc_winsserveraddress`

The DSC WinsServerAddress resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_winsserveraddress` type.

##### `dsc_address`

Data type: `Optional[Array[String]]`

The desired WINS Server address(es). Exclude to remove all WINS servers.

#### Parameters

The following parameters are available in the `dsc_winsserveraddress` type.

* [`dsc_interfacealias`](#-dsc_winsserveraddress--dsc_interfacealias)
* [`dsc_psdscrunascredential`](#-dsc_winsserveraddress--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_winsserveraddress--dsc_timeout)
* [`name`](#-dsc_winsserveraddress--name)
* [`validation_mode`](#-dsc_winsserveraddress--validation_mode)

##### <a name="-dsc_winsserveraddress--dsc_interfacealias"></a>`dsc_interfacealias`

namevar

Data type: `String`

Alias of the network interface for which the WINS server address is set.

##### <a name="-dsc_winsserveraddress--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_winsserveraddress--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_winsserveraddress--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_winsserveraddress--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_winssetting"></a>`dsc_winssetting`

The DSC WinsSetting resource type.
Automatically generated from version 9.0.0

#### Properties

The following properties are available in the `dsc_winssetting` type.

##### `dsc_enabledns`

Data type: `Optional[Boolean]`

Specifies if DNS is enabled for name resolution over WINS for all network adapters with TCP/IP enabled.

##### `dsc_enablelmhosts`

Data type: `Optional[Boolean]`

Specifies if LMHOSTS lookup should be enabled for all network adapters with TCP/IP enabled.

#### Parameters

The following parameters are available in the `dsc_winssetting` type.

* [`dsc_issingleinstance`](#-dsc_winssetting--dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#-dsc_winssetting--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_winssetting--dsc_timeout)
* [`name`](#-dsc_winssetting--name)
* [`validation_mode`](#-dsc_winssetting--validation_mode)

##### <a name="-dsc_winssetting--dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes', 'yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="-dsc_winssetting--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_winssetting--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_winssetting--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_winssetting--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

